var path = require("path");
var fs = require('fs');

function isValid(obj, props) {
	if (typeof obj != 'object' || obj == null)
		return false;
	var exist=0;
	props.map(prop=>{
		if(obj[prop]!=undefined)
			exist++;
	});

	if (exist < props.length)
		return false;

	return true;
}
if (!global.asyncReturn) 
	global.asyncReturn = (function () {
		function then (_callback) {
			if (this._then){
				this._listThen.push(_callback);
				return this;
			}
			this._then = _callback;
			
			
			if(this.cache.then)
				this.callThen.apply(this, this.cache.then);
			return this;
		}
		function error (_callback) {
			if (this._error){
				this._listError.push(_callback);
				return this;
			}

			this._error = _callback;
			
			if(this.cache.error)
				this.callError.apply(this, this.cache.error);
			return this;
		}
		function done(_callback) {
			this._done = _callback;
			
			return this;
		}
		function callNextPromise(promiseRes) {
			if (promiseRes && promiseRes instanceof constructor) {
				if (this._listThen[this._nextPromise])
					promiseRes.then(this._listThen[this._nextPromise].bind(this));

				if (this._listError[this._nextPromise])
					promiseRes.error(this._listError[this._nextPromise].bind(this));

			}
			this._nextPromise++;

			return this;
		}
		function callThen () {
			var promiseRes;
			if (this._then) 
				promiseRes = this._then.apply(this, arguments);
			else 
				this.cache['then'] = arguments;

			this.callDone();
			return callNextPromise.call(this, promiseRes);
		}
		function callError () {
			var promiseRes;
			if (this._error) 
				promiseRes = this._error.apply(this, arguments);
			else 
				this.cache['error'] = arguments;

			this.callDone();
			return callNextPromise.call(this, promiseRes);
		}
		function callDone () {
			if(this._done) this._done.apply(this, this.cache.then, this.cache.error);
			else this.cache['_done'] = [this.cache.then, this.cache.error];
			
			return this;
		}
		function constructor() {
			this._nextPromise = 0;
			this._listThen = [];
			this._listError = [];
			this.cache = {}; 
			this.then = then;
			this.error = error;
			this.catch = error;
			this.done = done;
			this.callThen = callThen;
			this.callError = callError;
			this.callDone = callDone;
		}

		function create(){
			return new constructor();
		}
		/**
		 *
		 *
		 **/
		function donePoolPromises(_fn) {
			this._done = _fn;
			return this;
		}
		function doneController(promise, result, err) {
			this._responses.push({
				promise, result, err
			});
			if(this._total === this._responses.length){
				//	IS READY
				this._done(this._responses);
				return this;
			}
		}
		function addPromise(promise) {
			if (Array.isArray(promise)) {
				promise.forEach(prom=>{
					this._total++;
					this._promises.push(prom);
					if (typeof prom.done == 'function') {
						prom.done( doneController.bind(this, prom) );
					}
					else if (typeof prom.then == 'function'){
						prom.then( doneController.bind(this, prom) );
						prom.error( doneController.bind(this, prom) );
					}		
				});
			}else{
				this._total++;
				this._promises.push(promise);
				if (typeof promise.done == 'function') {
					promise.done( doneController.bind(this, promise) );
				}
				else if (typeof promise.then == 'function'){
					promise.then( doneController.bind(this, promise) );
					promise.error( doneController.bind(this, promise) );
				}
			}
		}
		function PromiseList(argument) {
			this._total= 0;
			this._promises= [];
			this._responses= [];
			this._done = function(){};

			this.add = addPromise;
			this.done = donePoolPromises;
			this.then = donePoolPromises;

			if(Array.isArray(argument))
				addPromise.call(this, argument);
		}
		function promiseList(argument) {
			return new PromiseList(argument);
		}
		return {
			create: create,
			constructor: constructor,
			pool: promiseList
		}
	})();
var ControllerUtil = (function () {
	/**
	 *	PRIVATE SINGLETON 
	 **/
	var Util = {
		schemas: {}
	};
	function getSchema(name) {
		return Util.schemas[name];
	}
	function setSchema(name, schema) {
		if (!name)
			do{
				name= "schema-"+randomString(4);
			}while(!name);

		Util.schemas[name] = schema;
	}
	/**
	 *	GENERAL METHODS	
	 *	
	 **/
	function randomString(length) {
	    var chars = '0123456789ABCDEFGHIJKLMNOPQRSTUVWXTZabcdefghiklmnopqrstuvwxyz'.split('');

	    if (! length) {
	        length = Math.floor(Math.random() * chars.length);
	    }

	    var str = '';
	    for (var i = 0; i < length; i++) {
	        str += chars[Math.floor(Math.random() * chars.length)];
	    }
	    return str;
	}

	/**
	 *
	 *
	 **/
	function Schema(configuration, name) {
		if (typeof configuration !== 'object'){
			throw Error("Error Invalid controller configuration");
			return null;
		}

		var path_folder = path.dirname(module.parent.filename);
		if (typeof configuration.controllers === 'string'){
			var stats = fs.statSync(path.resolve(configuration.controllers));
			if(stats.isDirectory())
				path_folder = configuration.controllers;
		}

		this.name = name;
		this.controllerFileNames = [];
		this.controllerNames = [];
		this.loadedControllers = {};
		this._processing = [];
		this.path_folder = path_folder;
		this._loadatones = true;

		/*
		 *
		 */
		readControllerFiles.call(this);
	}

	//	START CREATING THE GETTERS AS ALL THE CONTROLLERS FILES.
	Schema.prototype.init = function(){
		/*
		 *	EXPOSE THE GET CONTROLLER METHOD
		 */
		Object.defineProperty(this.baseController.controller, 'getController', {
			enumerable: true,
			value: getController.bind(this)
		});

		/*
		 *	EXPOSE OTHER PROPERTIES BY METHOD INIT
		 */
		var promInit;
		if (this.baseController && this.baseController.init)
			promInit = this.baseController.init.apply(this.baseController, arguments);
		/*
		 *	LOAD ALL CONTROLLERS IF NEEDED
		 */
		if (this._loadatones)
			if (promInit instanceof Promise)
				promInit.then(loadAllControllers.bind(this))
			else
				loadAllControllers.call(this);
		return this;
	};

	function addController(name, fileName) {
		//console.log(fileName);
		if (name != 'index') {
			this.controllerFileNames.push(fileName);
			this.controllerNames.push(name);
			//	CREATE A GETTER THAT GIVES ACCESS TO THE MODEL
			this.__defineGetter__( name, getController.bind(this, name) );
		}
	}
	function getController (controllerName) {
		if (this._processing[controllerName]) {
			return this._processing[controllerName];
		}
		//  console.log('Looking for: '+controllerName);
		//	LOAD THE MODEL REQUIRED IF IS NOT LOADED YET
		if ( !this.loadedControllers[controllerName] )
			return loadController.call(this, controllerName) ;
		else
			return this.loadedControllers[controllerName];
	}
	/**
	 *	PROCCESS THE REQUIRED CONTROLLER AND 
	 *	CREATE A NEW OBJECT WITH THE PROPERTYS OF IT, BUT AIMING TO A CHARE FUNCTION HANDLER
	 **/	
	function proccessController (controllerName, controller) {
		if (controllerName !== 'baseController' && this.loadedControllers['baseController'])
			controller.prototype = this.loadedControllers['baseController'].controller;
		
		var shotCut= {

		}
		this._processing[controllerName] = shotCut;
		var controller = new controller();
		delete this._processing[controllerName];

		console.log('Proccessing controller: '+controllerName);
		//console.log(controller);
		var methodNames = Object.getOwnPropertyNames(controller);

		shotCut.controller = controller;
		shotCut.methods = [];
		shotCut.methodNames = [];

		for (var i = 0; i < methodNames.length; i++) {
			if(typeof controller[ methodNames[i] ] == 'function')
				shotCut[ methodNames[i] ] = exeMothod.bind(shotCut, methodNames[i]);
			else
				shotCut[ methodNames[i] ] = controller[ methodNames[i] ];

			shotCut.methods.push( controller[methodNames[i]] );
			shotCut.methodNames.push( methodNames[i] );
		};
		//console.log('+++ Controller Ready +++');
		//console.log(methodNames);
		this.loadedControllers[controllerName] = shotCut;
		return this.loadedControllers[controllerName];
	}
	//	LOADER OF CONTROLLERS
	function loadController (controllerName) {
		// IF THE SPECIFIC CONTROLLER IS IN THE CONTROLLERS DIRECTORY
		if ( (i = this.controllerFileNames.indexOf(controllerName+'.js') ) > -1 ){
			console.log('Require File Controller : '+this.controllerFileNames[i]);
			try{
				var funOrObj = require(path.join(this.path_folder, this.controllerFileNames[i]) );
			}catch(err){
				throw err
			}
			// CHECK IF THE REQUIRED FILE IS A FUNCTION ->CONTROLLER
			//	OR IS A OBJECT ->THE BASE CONTROLLER.
			if (typeof funOrObj == 'function'){
				return proccessController.call(this, controllerName, funOrObj );
			}
			else{
				throw Error('Invalid controller: '+controllerName+'.js');
			}
		}
		else{
			console.log('File not fount: '+controllerName+'.js');
			return undefined;
		}
	}
	function readControllerFiles() {
		fs.readdirSync(this.path_folder).forEach(fileName=>{
			var controllerName = fileName.replace('.js','');
			addController.call(this, controllerName, fileName);
		});
	}
	function loadAllControllers () {
		for (var i = 0; i < this.controllerNames.length; i++) {
			var controllerName = this.controllerNames[i];
			getController.call(this, controllerName);
		};
		Object.keys(this.loadedControllers).forEach(name=>{
			/* 	Omit baseController 	*/
			if (name == 'baseController')
				return 0;

			var cn = this.loadedControllers[name];
			if (typeof cn == 'object' && typeof cn.init == 'function')
				cn.init();
		});
		return true;
	}

	//	HANDLER FUNCTION OF 'X' CONTROLLER METHOD. THIS AIM TO THE SHORTCUT CONTROLLER
	function exeMothod (methodName) {
		var pasArguments = Array.prototype.slice.call(arguments);
			pasArguments.shift();
		var result = this.controller[methodName].apply(this.controller,pasArguments);
		if (typeof result == 'object' && typeof result.then === 'function')
			return result;
		else
			return Promise.resolve(result);
	}
	return {
		createSchema: function (configuration, name) {
			var schema = new Schema(configuration, name);
			setSchema(name, schema);
			return schema;
		},
		constructor: Schema,
		getSchema: getSchema
	}
})();

exports = module.exports = ControllerUtil.createSchema;

exports.getSchema = ControllerUtil.getSchema;